import smtplib
import sys

from email.Charset import Charset, QP, BASE64 
from email.MIMEMultipart import MIMEMultipart 
from email.MIMEText import MIMEText
from email.Utils import formatdate, formataddr
from announcer.util.mail import set_header


try:
    from email.header import Header 
except:
    from email.Header import Header
from subprocess import Popen, PIPE

user = 't.mosko@hitron.pl'
password   = 'asdfgh'
host = 'hitron.pl'
port = 25
from_addr   = u't.mosko@hitron.pl'
recipients  = ('tomaszmosko@o2.pl',)
message  = ("From: %s\r\nTo: %s\r\n\r\n" % (from_addr, ", ".join(recipients)))
timeout = 30
debuglevel = 1
from_name = "Tomek"
email_from = 't.mosko@hitron.pl'
replyto='t.mosko@hitron.pl'

rootMessage = MIMEMultipart("related")
# TODO: is this good? (from jabber branch)
#rootMessage.set_charset(self._charset)

headers = dict()
headers['Message-ID'] = 1
headers['Date'] = formatdate()
from_header = formataddr((
	from_name,
	email_from
))
headers['From'] = from_header
headers['To'] = '"%s"'%(recipients)

headers['Reply-To'] = replyto

for k, v in headers.iteritems():
	set_header(rootMessage, k, v)

rootMessage.preamble = 'This is a multi-part message in MIME format.'
parentMessage = rootMessage

_charset = Charset()
_charset.input_charset = 'utf-8'
_charset.header_encoding = BASE64
_charset.body_encoding = BASE64
_charset.output_charset = 'utf-8'
_charset.input_codec = 'utf-8'
_charset.output_codec = 'utf-8'

msg_format = 'html'
output = ''
msgText = MIMEText(output, msg_format)
del msgText['Content-Transfer-Encoding']
msgText.set_charset(_charset)
parentMessage.attach(msgText)

recip_adds = [x[2] for x in recipients if x]
# Append any to, cc or bccs added to the recipient list
for field in ('To', 'Cc', 'Bcc'):
	if rootMessage[field] and \
			len(str(rootMessage[field]).split(',')) > 0:
		for addy in str(rootMessage[field]).split(','):
			recip_adds.append(addy)

# replace with localized bcc hint
if headers['To'] == 'undisclosed-recipients: ;':
	set_header(rootMessage, 'To', _('undisclosed-recipients: ;'))

#package = (from_header, recip_adds, rootMessage.as_string())

# use defaults to make sure connect() is called in the constructor
smtpclass = smtplib.SMTP

args = {
	'host': host,
	'port': port
}

# timeout isn't supported until python 2.6
vparts = sys.version_info[0:2]

if vparts[0] >= 2 and vparts[1] >= 6:
	args['timeout'] = timeout

smtp = smtpclass(**args)

smtp.set_debuglevel(debuglevel)
smtp.ehlo()
smtp.starttls()
smtp.ehlo()
smtp.login(user.encode('utf-8'), password.encode('utf-8'))
smtp.sendmail(from_header, recip_adds, msgText.as_string())

# avoid false failure detection when the server closes the 
# SMTP connection with TLS/SSL enabled
import socket
try:
	smtp.quit()
except socket.sslerror:
	pass

